#include <inttypes.h>
#include <avr/io.h>
#include <avr/interrupt.h>
//#include <util/delay.h>
// Standard Input/Output functions
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <math.h>


#define  FT232RL_RST		PB2
#define  BUTTON_DEAD_TIME	50
#define RX_BUFFER_SIZE 256
#define RXB8 1
#define TXB8 0
#define UPE 2
#define OVR 3
#define FE 4
#define UDRE 5
#define RXC 7

#define FRAMING_ERROR (1<<FE)
#define PARITY_ERROR (1<<UPE)
#define DATA_OVERRUN (1<<OVR)
#define DATA_REGISTER_EMPTY (1<<UDRE)
#define RX_COMPLETE (1<<RXC)
//I2C sensor
#define START	0x08
#define MT_SLA_ACK	0x18
#define MT_SLA_NACK	0x20
#define MT_DATA_ACK 0x28
#define MT_DATA_NACK 0x30
#define MR_SLA_ACK	0x40
#define MR_DATA_ACK 0x50
#define MR_DATA_NACK 0x58
#define SLA_W	0b10010000
#define SLA_R	0b10010001
#define SLA2_W	0b10010010
#define SLA2_R	0b10010011
#define START	0x08
#define MT_SLA_ACK	0x18
#define MT_SLA_NACK	0x20
#define MT_DATA_ACK 0x28
#define MT_DATA_NACK 0x30
#define MR_SLA_ACK	0x40
#define MR_DATA_ACK 0x50
#define MR_DATA_NACK 0x58

#define ADC_VREF_TYPE 0x00 

// Declare your global variables here

/////Port masks for extension test
const unsigned int mask_port_a  = 0x03 ; 
const unsigned char mask_port_b  = 0xF0;
int test=0;
	


//temps
unsigned int a=0;
unsigned char i=0;
unsigned char j,k;
unsigned char proba;
unsigned char temp_array [64];
/////////////////
int s,button_filter;
int butflag=0;

//unsigned char rx_proba [256];
//double tempcalc,tempcalc2;
//int index1;
unsigned int res_l, res;
 int t=0;

int l=0;
int com_out =0;
int flag=0;
int ring_state=0;
int RI=0;
char ok[2]={'O','K'};
char RING [6] = {'R', 'I', 'N', 'G', '\r'};
char nocarrier[10]={'N','O',' ','C','A','R','R','I','E','R'};
char callready[10]={'C','a','l','l',' ','R','e','a','d','y'};
int opencall=0;
int opencall2=0;
int butpress=0;
int notcall=1;
int stopbuzzer=0;
int usbplug=0;
int RIchange=0;
int RIerror=0;
// USART Receiver buffer

char rx_buffer[RX_BUFFER_SIZE];
int rx_wr_index,rx_rd_index;
volatile int rx_counter;//unsigned char
// This flag is set on USART Receiver buffer overflow
unsigned char rx_buffer_overflow;

//I2C sensor
unsigned char conf_pointer;
unsigned char Ta_pointer;
unsigned char TCN_Conf;
unsigned int TCN_Data;
unsigned char TCN_raddr,TCN_waddr;
int er;
uint16_t temph,templ,temp;
double tempwr;	
double tempwr2;

void Delay (unsigned long a) { while (--a!=0); }
//////////////////////////////////////////////////////////////////////////////
void Init()
{// Input/Output Ports initialization
// Port A initialization
// Func7=Out Func6=In Func5=Out Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=0 State4=T State3=T State2=T State1=T State0=T 
PORTA=0x00;
DDRA=0x00;	

// Port B initialization
// Func7=In Func6=In Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=T State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTB=0x00;
DDRB=0x00;

// Port C initialization
// Func7=Out Func6=Out Func5=In Func4=In Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=0 State5=T State4=T State3=T State2=T State1=T State0=T 
PORTC=0x00;
DDRC=0xC0;

// Port D initialization
// Func7=Out Func6=In Func5=In Func4=Out Func3=In Func2=In Func1=In Func0=In 
// State7=0 State6=T State5=T State4=T State3=T State2=T State1=T State0=T 
PORTD=0x00;
DDRD=0x92;


// Timer/Counter 1 initialization
// Clock source: System Clock
// Clock value: 6000,000 kHz
// Mode: Normal top=FFFFh
// OC1A output: Discon.
// OC1B output: Toggle
// Noise Canceler: Off
// Input Capture on Falling Edge
TCCR1A=0x10;//enable Timer/Counter 1 B output,Normal mode ;
TCCR1B=0x01;//Clock source with no prescaling
TCNT1H=0x00;
TCNT1L=0x00;
ICR1H=0x00;
ICR1L=0x00;
OCR1AH=0x00;
OCR1AL=0x00;
//proba
OCR1BH=0x07;
OCR1BL=0x2A;

//OCR1BH=0x05;
//OCR1BL=0x52;


GICR|=0x80;
MCUCR=0x08;
MCUCSR=0x00;
GIFR=0x80;
// Timer(s)/Counter(s) Interrupt(s) initialization

//TIMSK=0x02;

//--------interrupt--------
// USART initialization
// Communication Parameters: 8 Data, 1 Stop, No Parity
// USART Receiver: On
// USART Transmitter: On
// USART Mode: Asynchronous
// USART Baud rate: 115.2 kbps
	if(PIND & 0b00100000)
		{
		PORTA=0x00;
		DDRA=0x00;	
		PORTD=PORTD & 0b11111100;
		DDRD =DDRD &  0b11111100;
		}
		else
		{
			PORTB &= ~(1<<PB2);//hold FT232RL in reset
			DDRB |= 0x04;	

			PORTA &= 0b01011111;//disable SLEEP mode with RTS=0; DTR =0
			DDRA |=  0b10100000;
			UCSRA=0x00;
			UCSRB=0x98;
			UCSRC=0x86;
			UBRRH=0x00;		//0x00;5F
			UBRRL=0x03;		//2F->>9600 at 7.3278 ;0x26;-->baudrate 9600 at clock=6 MHz
		}


// Timer(s)/Counter(s) Interrupt(s) initialization
//TIMSK=0x00;//timer interrupt disable
		TIMSK=0x08;

// Analog Comparator initialization
// Analog Comparator: Off
// Analog Comparator Input Capture by Timer/Counter 1: Off
// Analog Comparator Output: Off
		ACSR=0x80;
		SFIOR=0x00;
//ADC module
		ADMUX=ADC_VREF_TYPE;
	 	ADCSRA=0x80;
// Global enable interrupts
asm volatile("sei");
//#asm("sei")

}

/////////////////////////////////////////////////
static void putchr(char c)
{

  loop_until_bit_is_set(UCSRA, UDRE);
  UDR = c;
}
///////////////////////////////////////////////////////////////
void Send_UART(unsigned char * byte)
{
	for (;*byte;++byte)	putchr (*byte);
	putchr(13);
	}


////////////////////////////////////////////////////////////////////////

char getchar_UART(unsigned long timeout)
{
	char data;
	//wait given timeout
	while ((rx_counter==0) && (timeout >0))
			timeout--;
	if(timeout==0)// (rx_counter==0)
		{
		com_out=1;
		return;
		}
	data=rx_buffer[rx_rd_index];
	if (rx_counter>0)
		if (++rx_rd_index == RX_BUFFER_SIZE) rx_rd_index=0;

	asm volatile("cli");

	if(rx_counter>0)	--rx_counter;

	asm volatile("sei");

	return data;
}

/////////////////////////////////////////////////////////////////////
// USART Receiver interrupt service routine
ISR(USART_RXC_vect)
//interrupt [USART_RXC] void usart_rx_isr(void)
{
char status,data;
status=UCSRA;
data=UDR;
if ((status & (FRAMING_ERROR | PARITY_ERROR | DATA_OVERRUN))==0)
   {
   rx_buffer[rx_wr_index]=data;
   if (++rx_wr_index == RX_BUFFER_SIZE) rx_wr_index=0;
   if (++rx_counter == RX_BUFFER_SIZE)
      {
      rx_counter=0;
      rx_buffer_overflow=1;
      };
   };
}


///////////////////////////////////////////////////////////////

unsigned char Compare (void)
{
   unsigned char a, b;// temp;
   b=0;
   for (a=0; a<5; a++)
	 {
//		temp = getchar_UART();
		
	 	if (temp_array[b++] != RING[a]) return 0;		  
	 }	
	 return 1;
}

//////////////////////////////////////////////////////////////////////
void error(char * err)
{
//printf("Error:%s\n",err);
er=er+1;
}
////////////////////////////////////////////////////////////////////
int waitplus()
{
	//com_out=0;
	//Feature:can exit by timeout
	int l=0;
	int flag=0;
	
	while (	(getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}
//	if(!com_out){//very carefull
		proba=getchar_UART(100000);
//		proba=proba;
//		}
//	else return 0; //here exits by timeout
	
	if(proba==43)
	{
		flag=flag+1;
	}
	
	return flag;
}
////////////////////////////////////////////////////////////////////
int waitOK()
{ 
	//Feature:can exit by timeout
	int l=0;
	int flag=0;
	char ok[2]={'O','K'};
	com_out=0;

	if((getchar_UART(100000)==13) && (!com_out))	flag=flag;// CR(13)while (!=10)
	if((getchar_UART(100000)==10) && (!com_out)) flag=flag;//LF(10)
	
	
	if(com_out)
		return 0; //here exits by timeout

	while(ok[l++]==getchar_UART(100000))
	{
		flag=flag+1;
	}
	
	if((getchar_UART(100000)==13) && (!com_out)) flag=flag;
	if((getchar_UART(100000)==10) && (!com_out)) flag=flag;

	return flag;
}

/////////////////////////////////////////////////////////////
void waitcarrier(void)
{
	//Feature: can exit by timeout
	int l;
	int flag=0;
	
	
	while (	(getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}
	
	while((nocarrier[l++]==getchar_UART(70000)) && (!com_out))
	{
		flag=flag+1;
	}
	
	while (	(getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}

}

//////////////////////////////////////////////////////////////////////////////////////////
int  call_ready(void)
{
	//Feature: can exit by timeout 
	int l=0;
	int flag=0;
	int match=0;
	//wait for a new line
	while (	(getchar_UART(100000)!=10) && (!com_out))
	{
		l=l;
	}

	while(!match)
	{
		if(rx_wr_index)//if(!com_out)
		{
			proba=getchar_UART(70000);
		}
		else 	return; //here exits  by timeout

		if (callready[l]==proba)	//first symbol
			{
				l=l+1;
				if (callready[l]==getchar_UART(70000))	//second symbol
					{
					match=match+1;
					while(callready[++l]==getchar_UART(70000))
						{
						flag=flag+1;
						}
					}
				else l=0;
			}
	}
	//wait for a new line			
	while (	getchar_UART(70000)!=10)
	{
		l=l;
	}
	
	com_out=0;	//reset timeout flag 
	return match;
}

//////////////////////////////////////////////////////////////////////////////////////////

// External Interrupt 1 service routine
ISR(INT1_vect)
//interrupt [EXT_INT1] void ext_int1_isr(void)
{	
	do
		{
		butflag=0;
		for(button_filter=0;button_filter<BUTTON_DEAD_TIME;button_filter++)
			if (PIND & 0b00001000)
				butflag=1;//butflag+
				else butflag=0;
		}
	while (butflag>0);
// butpress indicate button pressed		
	butpress=1;
	Togle_REL1 ();
	
}

/////////////////////////////////////////////////////////////////////////////////////////////
// Timer 1 output compare interrupt service routine
ISR(TIMER1_COMPB_vect)
{
	t++;
	TCNT1=0;	//clear TCNT1 value(to imitate CTC mode on Timer 1 B)
//1.check whether to toggle or not(buzzer_enable);
	if (stopbuzzer || (t==4000))
		TCCR1A=0x0;//disconnect Timer/Counter 1 A/B Output pin
			
//2.check for plugged USB(check pin) and respectively hold USB reset  or not			
	if(PIND & 0b00100000)
			usbplug=1;
		else usbplug=0;
}

///////////////////////////////////////////////////////////////////////////////////////////

void Togle_REL1 (void)
{
	DDRC |= 0x80;
	PORTC ^= 0x80;
}
void Set_REL1 (void)
{
	DDRC |= 0x80;
	PORTC|= 0x80;
}
void Togle_REL2 (void)
{
	DDRC |= 0x40;
	PORTC ^= 0x40;

}
void Set_REL2 (void)
{
	DDRC |= 0x40;
	PORTC |= 0x40;
}

void Togle_LED (void)
{
	DDRD |= 0x80;
	PORTD ^= 0x80;
}


int setrate(void)
{

	Send_UART("AT+IPR=115200");
	if (!waitOK())
			return 0;
	
	UBRRH=0x00;		//baudrate=115 200
	UBRRL=0x03;

	Send_UART("AT&W");
	if (!waitOK())
			return 0;
}
////////////////////////////////////////////////////////////////
int gsmconfig(void)
{

	Send_UART("ATE0");//disable ECHO characters
	a=65535;
	while(--a!=0);

	if(!waitOK())
		return 0;
	com_out=0;
	
	Send_UART("AT+CMGF=1");//set text SMS format
		a=65535;
	while(--a!=0);
	if(!waitOK())
		return 0;	
	com_out=0;
}
/////////////////////////////////////////////////////////////////////////////
/*
Functions:
1.Recognize ring and open call on mic or on aux. channel.
2.in1			----------> Relay1
3.in2			----------> Relay2

Following Error codes are realized:
     ____________________________________
	|error			|		action		|
	|_______________|___________________|
	|extension		|		1 Led blink |
	|_______________|___________________|
	|I2C temp	    |		2 Led blink |
    |_______________|___________________|
	|RI not change  |		3 Led blink |
	|_______________|___________________|
	DTR and Sleep mode of SIM module is problematic 
P.S.:Internal TCN temp sensor has I2C hardware address 	000, but we use external one
with address 010.
*/

//=====================================================================================================
int main(void)
{
	//	asm volatile("sei");
			k=0;
		//	er=0;
			int ch;
			ch=0;


	
////////////////////init UART and I/O ports	/////////////////////
			Init();
///////////////////////act as PowerKey-it should be hold down about 1-2 seconds
			DDRA  = 0b00000100;//PA2 out in zero
			Delay(1500000);
			PORTA &=0b11111011;
			DDRA  &=0b11111011;//PA2 back input 
////////////////////wait for Call Ready/////////////////////////////////////			
			//while(rx_counter==0); //check this
			call_ready();	//return 0;
		//	else stopbuzzer=stopbuzzer+1;
//Find appropriate baudrate to communicate with SIM module	and then set rate=115200	|||//(findfreq()==1) ||(findfreq()==2)
		//	if(findfreq>0) 		
		//		setrate();
	//set other SIM module settings
			gsmconfig();
			com_out=0; // zero commmunication timeout timer
		
		TCCR1A ^=0x10;
		for (int c=0; c<30000;c++);
		TCCR1A ^=0x10;
///////////////////////////////////////////////////////////////////////////					
	while (1)
	{

//Check if GSM module is connected to power suply or use battery- in this case CPU is put into SLEEP mode
//That means that we  should measure voltage on ADC3 pin
		// Set chanel
			 ADMUX=(3|ADC_VREF_TYPE);
			 // Start the AD conversion
			 ADCSRA|=0x40;
			 // Wait for the AD conversion to complete
			 while (ADCSRA & 0x40); 
			 // get result
			 res_l = ADCL; 
			 res = ADCH; 
			 res <<=8;
			 res |= res_l;
			
			 if (res <50)
			 	{
			 		//PORTD = PORTD | 0x80;
					DDRD=DDRD & 0x7F;
					asm volatile("sleep");	//put CPU in SLEEP mode
					}
					else 
						{ 
						DDRD=DDRD | 0x80; //PORTD = PORTD & 0x7F;
						}
//////////////////////Config for terminal access or dialog with CPU/////////////////////////////
			if(usbplug)
					{
					UCSRA=0x00;
					UCSRB=0x00;
					UCSRC=0x00;
					UBRRH=0x00;		
					UBRRL=0x00;
					PORTA=0x00;					//RTS,CTS,DTR,DCD - inputs
					DDRA=0x00;	
					PORTD=PORTD & 0b10111100;	//RI,RTX,DTX- inputs 
					DDRD =DDRD &  0b10111100;
					if (res>50)  DDRD=DDRD | 0x80; 
					//PORTB &= ~(1<<PB2);//not hold FT232RL in reset
					PORTB &=0b11111011;
					DDRB &= 0b11111011;
					}
				else
					{
						//PORTB &= ~(1<<PB2);	//hold FT232RL in reset
						PORTB &=0b11111011;
						DDRB |= 0x04;	

						PORTA &= 0b01011111;	//disable SLEEP mode with RTS=0; DTR =0
						DDRA |=  0b10100000;
						PORTD=0x00;
						DDRD=0x12;
						if (res>50)  DDRD=DDRD | 0x80; 
						UCSRA=0x00;
						UCSRB=0x98;
						UCSRC=0x86;
						UBRRH=0x00;	
						UBRRL=0x03;	
						}
			 	
////////////////////////////////ring recognition////////////////////////////////////////////
		if(!(PIND & 0b01000000))
				RI++;

		if (rx_counter != 0)	
			 {		
			 //	com_out=0;

			 	k=0;
				if(!(PIND & 0b01000000))
					{
					if  (!RIchange)
						RIerror=1;
						else
							{
							RI++;
							stopbuzzer=0;
							}
					}
				if(!waitplus())
				
					{	
							for (k=0;k<64;k++)
								temp_array[k]="";
							k=0;
			                if (proba!= 10)
								temp_array[k++]=proba;	//very carefull	
							do
			  			 		{
						 	proba=getchar_UART(100000);
							if ((proba != 10) ) temp_array[k++]=proba;
								}
							while(proba != 10); 		//LF 			 
	
					 }
				
				if(Compare() && RI) 	
								{	
								ring_state=ring_state+1;
								TCCR1A ^=0x10;
								}
		}//end RING recognition 
				//	stopbuzzer=1;
				if (butpress && ring_state)	//ring_state
					{
								butpress=0;	
								ring_state=0;					
								notcall=0;
								TCCR1A=0x00;
												
						
								Send_UART("ATA");
								a=65535;
								while(--a!=0);

								opencall=opencall+1;

								while (	getchar_UART(100000)!=10) //wait new line 
									{
									l=l;
									}
	
								while(ok[l++]==getchar_UART(100000)) //read ok
									{
									flag=flag+1;
									}
			
								while (	getchar_UART(100000)!=10)
									{
										l=l;
									}

								Send_UART("AT+CHFA=0");//switch to FIRST audio channel
								a=65535;
								while(--a!=0);

								if(!waitOK())
										return 0;
								com_out=0;
					}
	//	}//end USART FIFO read  					
		    if(butpress && opencall)
							{						//When call is opened, then 
							Send_UART("AT+CHFA=1");//switch to auxilary audio channel
							a=65535;
							while(--a!=0);

							if(!waitOK())
									return 0;
							com_out=0;
							opencall=0;
							opencall2=opencall2+1;
							}

			if (butpress && opencall2) //|| (!(butpress || opencall)) \------- || (notcall && ring_state))	
						{ 
							waitcarrier();
							butpress=0;
							opencall2=0;
							DDRC  |= 0b11000000;	//turn-off relays 1 and 2
							PORTC &= 0b00111111;
						}
			//TCCR1A &=~(0x10);
		k=100;

	

	} //end second cycle
////////////////////////////////////////////////////////////////////////////////////////////
return 0;
}
